package
{
	import flash.utils.ByteArray;
	
	import org.papervision3d.core.math.Number3D;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.MovieMaterial;
	import org.papervision3d.materials.shaders.FlatShader;
	import org.papervision3d.materials.shaders.ShadedMaterial;
	import org.papervision3d.materials.shaders.CellShader;
	import org.papervision3d.materials.shaders.PhongShader;
	import org.papervision3d.materials.shaders.GouraudShader;

	public class ResourceManager
	{
		[Embed (source="../media/ball.dae", mimeType="application/octet-stream")]
		public static const Ball:Class;
		public static const BallXML:XML = function():XML{var byteArray:ByteArray = new Ball() as ByteArray; return new XML(byteArray.readUTFBytes(byteArray.length));}();
		
		[Embed (source="../media/goldroots.jpg")]
		public static const Tex1:Class;
		public static const Tex1_Tex:MovieMaterial = new MovieMaterial(new Tex1());
		
		[Embed (source="../media/greenslate.png")]
		public static const Tex2:Class;
		public static const Tex2_Tex:MovieMaterial = new MovieMaterial(new Tex2());
		
		[Embed (source="../media/greenswirls.jpg")]
		public static const Tex3:Class;
		public static const Tex3_Tex:MovieMaterial = new MovieMaterial(new Tex3());
		
		[Embed (source="../media/lava.jpg")]
		public static const Tex4:Class;
		public static const Tex4_Tex:MovieMaterial = new MovieMaterial(new Tex4());
		
		[Embed (source="../media/rainbow.jpg")]
		public static const Tex5:Class;
		public static const Tex5_Tex:MovieMaterial = new MovieMaterial(new Tex5());
		
		[Embed (source="../media/snakeskin.jpg")]
		public static const Tex6:Class;
		public static const Tex6_Tex:MovieMaterial = new MovieMaterial(new Tex6());
		
		[Embed (source="../media/earthbump1k.jpg")]
		public static const EarthBumpMap:Class;
		public static const EarthBumpMap_Tex:MovieMaterial = new MovieMaterial(new EarthBumpMap());
		
		[Embed (source="../media/earthmap1k.jpg")]
		public static const Earth:Class;
		public static const Earth_Tex:MovieMaterial = new MovieMaterial(new Earth());
		
		[Embed (source="../media/earthspec1k.jpg")]
		public static const EarthSpec:Class;
		public static const EarthSpec_Tex:MovieMaterial = new MovieMaterial(new EarthSpec());
		
		
		// shaders
		
		public static const light:PointLight3D = new PointLight3D();

		public static const Cell:CellShader = new CellShader(light, 0xFFFFFF, 0x000000, 5);
		public static const CellShaderMat:ShadedMaterial = new ShadedMaterial(ResourceManager.Tex1_Tex, Cell); 
		
		public static const Flat:FlatShader = new FlatShader(light, 0xFFFFFF, 0x000000);
		public static const FlatShaderMat:ShadedMaterial = new ShadedMaterial(ResourceManager.Tex2_Tex, Flat); 
		
		public static const Gouraud:GouraudShader = new GouraudShader(light, 0xFFFFFF, 0x000000);
		public static const GouraudShaderMat:ShadedMaterial = new ShadedMaterial(ResourceManager.Tex5_Tex, Gouraud );
		
		public static const Phong:PhongShader = new PhongShader(light, 0xFFFFFF, 0x000000, 40, ResourceManager.EarthBumpMap_Tex.bitmap, ResourceManager.EarthSpec_Tex.bitmap);
		public static const PhongShaderMat:ShadedMaterial = new ShadedMaterial(ResourceManager.Earth_Tex, Phong); 
	}
}